package cn.iocoder.yudao.module.pms.service.iotmodeltemplateattrs;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.pms.controller.admin.iotmodeltemplateattrs.vo.IotModelTemplateAttrsPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotmodeltemplateattrs.vo.IotModelTemplateAttrsSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotmodeltemplateattrs.IotModelTemplateAttrsDO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotmodeltemplateattrs.IotThingsModelDO;
import cn.iocoder.yudao.module.pms.dal.mysql.iotmodeltemplateattrs.IotModelTemplateAttrsMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.util.List;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.pms.enums.ErrorCodeConstant.IOT_DEVICE_TEMPLATE_ATTRS_NOT_EXISTS;

/**
 * PMS 功能优化 设备模板属性 Service 实现类
 *
 * @author 芋道源码
 */
@Service
@Validated
public class IotModelTemplateAttrsServiceImpl implements IotModelTemplateAttrsService {

    @Resource
    private IotModelTemplateAttrsMapper iotModelTemplateAttrsMapper;

    @Override
    public Long createIotDeviceTemplateAttrs(IotModelTemplateAttrsSaveReqVO createReqVO) {
        // 插入
        IotModelTemplateAttrsDO iotDeviceTemplateAttrs = BeanUtils.toBean(createReqVO, IotModelTemplateAttrsDO.class);
        iotModelTemplateAttrsMapper.insert(iotDeviceTemplateAttrs);
        // 返回
        return iotDeviceTemplateAttrs.getId();
    }

    @Override
    public void updateIotDeviceTemplateAttrs(IotModelTemplateAttrsSaveReqVO updateReqVO) {
        // 校验存在
        validateIotDeviceTemplateAttrsExists(updateReqVO.getId());
        // 更新
        IotModelTemplateAttrsDO updateObj = BeanUtils.toBean(updateReqVO, IotModelTemplateAttrsDO.class);
        iotModelTemplateAttrsMapper.updateById(updateObj);
    }

    @Override
    public void deleteIotDeviceTemplateAttrs(Long id) {
        // 校验存在
        validateIotDeviceTemplateAttrsExists(id);
        // 删除
        iotModelTemplateAttrsMapper.deleteById(id);
    }

    private void validateIotDeviceTemplateAttrsExists(Long id) {
        if (iotModelTemplateAttrsMapper.selectById(id) == null) {
            throw exception(IOT_DEVICE_TEMPLATE_ATTRS_NOT_EXISTS);
        }
    }

    @Override
    public IotModelTemplateAttrsDO getIotDeviceTemplateAttrs(Long id) {
        return iotModelTemplateAttrsMapper.selectById(id);
    }

    @Override
    public List<IotModelTemplateAttrsDO> getAttrsByDeviceId(Long id) {
        return iotModelTemplateAttrsMapper.getAttrsByDeviceId(id);
    }

    @Override
    public List<IotThingsModelDO> getAttrsByName(String name) {
        return iotModelTemplateAttrsMapper.getAttrsByName(name);
    }

    @Override
    public PageResult<IotModelTemplateAttrsDO> getIotDeviceTemplateAttrsPage(IotModelTemplateAttrsPageReqVO pageReqVO) {
        return iotModelTemplateAttrsMapper.selectPage(pageReqVO);
    }

    @Override
    public List<IotModelTemplateAttrsDO> getIotDeviceTemplateAttrs(IotModelTemplateAttrsPageReqVO reqVO) {
        return iotModelTemplateAttrsMapper.selectList(reqVO);
    }

}